#include "ImageProcs.h"

void FindExtrinsicCameraParams(float *point3d,float *point2d,int num,float focal,float *result){
  CvMat *cvpoint3d,*cvpoint2d;
  CvMat *cvintmat;
  CvMat *cvrvec,*cvtvec;
  CvMat *dist;

  cvpoint3d=cvCreateMat(num,3,CV_32F);
  cvpoint2d=cvCreateMat(num,2,CV_32F);

  memcpy(cvpoint3d->data.fl,point3d,sizeof(float)*num*3);
  memcpy(cvpoint2d->data.fl,point2d,sizeof(float)*num*2);

  cvintmat=cvCreateMat(3,3,CV_32F);
  cvSetZero(cvintmat);
  cvintmat->data.fl[0]=focal;
  cvintmat->data.fl[4]=focal;
  cvintmat->data.fl[8]=1.0;

  cvrvec=cvCreateMat(3,1,CV_32F);
  cvtvec=cvCreateMat(3,1,CV_32F);

  dist=cvCreateMat(5,1,CV_32F);
  cvSetZero(dist);

  cvFindExtrinsicCameraParams2(cvpoint3d,cvpoint2d,cvintmat,dist,cvrvec,cvtvec);

  memcpy(result,cvtvec->data.fl,sizeof(float)*3);
  memcpy(result+3,cvrvec->data.fl,sizeof(float)*3);

  cvReleaseMat(&cvpoint3d);
  cvReleaseMat(&cvpoint2d);
  cvReleaseMat(&cvintmat);
  cvReleaseMat(&cvrvec);
  cvReleaseMat(&cvtvec);
  cvReleaseMat(&dist);
}

void FindExtrinsicCameraParamsRANSAC(float *point3d,float *point2d,int num,float focal,float *result){
  CvMat *cvpoint3d,*cvpoint2d;
  CvMat *cvintmat;
  CvMat *cvrmat,*cvrvec,*cvtvec;
  CvMat *dist;

  cvpoint3d=cvCreateMat(num,3,CV_32F);
  cvpoint2d=cvCreateMat(num,2,CV_32F);

  memcpy(cvpoint3d->data.fl,point3d,sizeof(float)*num*3);
  memcpy(cvpoint2d->data.fl,point2d,sizeof(float)*num*2);

  cvintmat=cvCreateMat(3,3,CV_32F);
  cvSetZero(cvintmat);
  cvintmat->data.fl[0]=focal;
  cvintmat->data.fl[4]=focal;
  cvintmat->data.fl[8]=1.0;

  cvrmat=cvCreateMat(3,3,CV_32F);
  cvrvec=cvCreateMat(3,1,CV_32F);
  cvtvec=cvCreateMat(3,1,CV_32F);

  dist=cvCreateMat(5,1,CV_32F);
  cvSetZero(dist);

  cvFindExtrinsicCameraParams2(cvpoint3d,cvpoint2d,cvintmat,dist,cvrvec,cvtvec);
  cvRodrigues2(cvrvec,cvrmat,NULL);

  memcpy(result,cvtvec->data.fl,sizeof(float)*3);
  memcpy(result+3,cvrvec->data.fl,sizeof(float)*3);

  cvReleaseMat(&cvpoint3d);
  cvReleaseMat(&cvpoint2d);
  cvReleaseMat(&cvintmat);
  cvReleaseMat(&cvrmat);
  cvReleaseMat(&cvrvec);
  cvReleaseMat(&cvtvec);
  cvReleaseMat(&dist);
}

